.386
.model flat,stdcall
option casemap:none

include WME2.inc
include debug.inc
includelib debug.lib
include gdi.asm

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	mov		CommandLine,eax
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDM_MENU
	mov		wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    LOCAL ps:PAINTSTRUCT
    LOCAL rect:RECT
    

    
	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
		
;		Invoke GetDC, hWnd
;		mov hDC, eax
;		
;		
;		Invoke CreateCompatibleDC, NULL
;		mov m_dcMem, eax
;		
		Invoke GetDlgItem, hWin, IDC_WORLDMAP
		mov hWorldMap, eax
;		Invoke GetDlgItem, hWin, IDC_VSCROLL
;		mov hVSCROLL, eax
;		Invoke GetDlgItem, hWin, IDC_HSCROLL
;		mov hHSCROLL, eax
;	
;        Invoke LoadWorldMapBMP
;        
		Invoke LoadImage, NULL, Addr szWorldMapBMP, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE
		mov hBmp, eax
		;PrintDec eax
		;Invoke SendDlgItemMessage, hWin, IDC_WORLDMAP, STM_SETIMAGE, IMAGE_BITMAP, hWorldMapBMP
		;mov hWorldMapBMP, eax
		
		;invoke GetBitmapDC, Addr DC_WorldMapBMP, Addr szWorldMapBMP, Addr hWorldMapBMP, hWin
		;PrintDec hWorldMapBMP
		;Invoke SendDlgItemMessage, hWin, IDC_WORLDMAP, STM_SETIMAGE, IMAGE_BITMAP, hWorldMapBMP
		Invoke GetObject, hBmp, SIZEOF BITMAP, ADDR bminfo
        mov eax,bminfo.bmWidth
        mov cxDib,eax
        mov eax,bminfo.bmHeight
        mov cyDib,eax		
;		
;		Invoke GetDesktopWindow
;		Invoke GetDC, eax
;		mov hDC, eax
;		
;		Invoke CreateCompatibleDC, hDC
;		mov hSrcDC, eax
;		Invoke CreateCompatibleDC, hDC
;		mov hDestDC, eax
;		
;		Invoke SelectObject, hSrcDC, hWorldMapBMP
;		mov hBmpOrg1, eax
;		Invoke SendDlgItemMessage, hWin, IDC_WORLDMAP, STM_SETIMAGE, IMAGE_BITMAP, hBmpOrg1
;
;        Invoke CreateCompatibleBitmap, hDC, bminfo.bmWidth, bminfo.bmHeight
;        mov hBmpOrg2, eax
;        Invoke SelectObject, hDestDC, eax
;        
;        invoke BitBlt, hDestDC, 0, 0, bminfo.bmWidth,bminfo.bmHeight,hSrcDC,0,0,SRCCOPY
;        Invoke SelectObject, hDestDC, hBmpOrg2    
        ;invoke SendMessage,hWorldMap,STM_SETIMAGE,IMAGE_BITMAP, eax
        
      

       ; Invoke GetDesktopWindow
       ; invoke ReleaseDC,eax,hDC
        
       ; Invoke SelectObject,hSrcDC,hBmpOrg1
       ; invoke DeleteObject,eax

	;	invoke DeleteDC,hSrcDC
	;	invoke DeleteDC,hDestDC
		
		;.IF eax != NULL
		;    Invoke SendDlgItemMessage, hWin, IDC_WORLDMAP, STM_SETIMAGE, IMAGE_BITMAP, hWorldMapBMP
		;.ENDIF
        ;invoke GetDC,hWin
        ;mov hDC, eax
        ;Invoke GetBitmapDC, Addr DC_WorldMapBMP, Addr szWorldMapBMP, Addr hWorldMapBMP, hWin
        ;Invoke GetCompatibleBitmap,  Addr DC_WorldMapBMP, Addr hDC_WorldMap, hWin, 200, 200
        
        ;Invoke BlitWindow, hWin, hDC, hWorldMapBMP, BW_COPY
		
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,addr AppName,addr AboutMsg,NULL
		.endif

    .elseif eax==WM_PAINT
		invoke BeginPaint, hWin, addr ps
		invoke CreateCompatibleDC, ps.hdc
        mov mdc1, eax
        invoke CreateCompatibleDC, ps.hdc
        mov mdc2, eax
		invoke GetClientRect,hWin, Addr rect
		invoke CreateCompatibleBitmap, ps.hdc, rect.right, rect.bottom
        mov membmp,eax
        invoke SetStretchBltMode, mdc1, COLORONCOLOR
        invoke SelectObject, mdc1, membmp
        mov membmp,eax
        invoke SelectObject, mdc2, hBmp
        mov hBmp, eax
        invoke BitBlt, mdc1, 0, 0, rect.right, rect.bottom, mdc2, 0, 0, SRCCOPY
       ; invoke StretchBlt, mdc1, 0, 0, rect.right, rect.bottom, mdc2, 0, 0, cxDib, cyDib, SRCCOPY
        invoke GetDC, hWin
        mov hDC, eax
        invoke BitBlt, hDC, 0, 0, rect.right, rect.bottom, mdc1, 0, 0, SRCCOPY
        invoke ReleaseDC, hWin, hDC

        invoke SelectObject,mdc1, membmp
        invoke DeleteObject,eax
        invoke SelectObject,mdc2, hBmp
        mov hBmp,eax

        invoke DeleteDC, mdc1
        invoke DeleteDC, mdc2
    
		;invoke BitBlt,ps.hdc, 0,0,bminfo.bmWidth,bminfo.bmHeight,DC_WorldMapBMP,0,0,SRCCOPY
        invoke EndPaint, hWin, addr ps
        mov eax, TRUE
        ret
		
;	.elseif eax == WM_PAINT
;	    Invoke IsIconic, hWin
;	    .IF eax == TRUE
;	        Invoke SendMessage, hWin, WM_ICONERASEBKGND, hDC, 0
;            ; // Center icon in client rectangle
;            Invoke GetSystemMetrics, SM_CXICON
;            mov cxIcon, eax
;            Invoke GetSystemMetrics, SM_CYICON
;            mov cyIcon, eax
;            Invoke GetClientRect, Addr rect
;            
;            mov eax, rect.right
;            mov ebx, rect.left
;            sub eax, ebx
;            mov ebx, cxIcon
;            add ebx, 1
;            sub eax, ebx
;            xor edx, edx
;            mov ecx, 2
;            div ecx
;            mov x, eax
;            
;            mov eax, rect.bottom
;            mov ebx, rect.top
;            sub eax, ebx
;            mov ebx, cyIcon
;            add ebx, 1
;            sub eax, ebx
;            xor edx, edx
;            mov ecx, 2
;            div ecx
;            mov y, eax
;            
;            Invoke DrawIcon, hDC, x, y, m_hIcon
;            
;;        int cxIcon = GetSystemMetrics(SM_CXICON);
;;        int cyIcon = GetSystemMetrics(SM_CYICON);
;;        CRect rect;
;;        GetClientRect(&rect);
;;        int x = (rect.Width() - cxIcon + 1) / 2;
;;        int y = (rect.Height() - cyIcon + 1) / 2;
;;
;;        // Draw the icon
;;        dc.DrawIcon(x, y, m_hIcon);
;	    .ELSE
;	        Invoke BitBlt, hDC, offsetx, offsety, m_size.x, m_size.y, m_dcMem, sourcex, sourcey, SRCCOPY
	    ;.ENDIF
	    	
	.elseif eax==WM_SIZE
	    .IF wParam == SIZE_MAXIMIZED	
	        Invoke GetWindowRect, hWin, Addr rect
	        mov eax, bminfo.bmWidth
	        add eax, 32d
	        mov ebx, bminfo.bmHeight
	        add ebx, 64d
	        Invoke MoveWindow, hWin, rect.left, rect.top, eax, ebx, TRUE
	    .ENDIF
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
	    Invoke DeleteDC, DC_WorldMapBMP
	    Invoke DeleteObject, hWorldMapBMP
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp


LoadWorldMapBMP PROC
    LOCAL rectStaticClient:RECT
    LOCAL horz:SCROLLINFO
    LOCAL vert:SCROLLINFO

; This basic example works, but image overflows the static control size, need to 'bound' it to our defined viewport (static control) size.
;		Invoke LoadImage, NULL, Addr szWorldMapBMP, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE
;		mov hWorldMapBmp, eax
;		.IF eax != NULL
;		    Invoke SendDlgItemMessage, hWin, IDC_WORLDMAP, STM_SETIMAGE, IMAGE_BITMAP, hWorldMapBmp
;		.ENDIF

    mov offsetx, 0
    mov offsety, 0
    mov sourcex, 0
    mov sourcey, 0
   
    Invoke LoadImage, NULL, Addr szWorldMapBMP, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE
    mov m_hBmpNew, eax
    .IF m_hBmpNew == NULL
        PrintText 'Load Image Failed'
        mov eax, FALSE
        ret
    .ELSE
        Invoke GetClientRect, m_hBmpNew, Addr rectStaticClient
        
        mov eax, rectStaticClient.left
        mov m_size.x, eax
        mov eax, rectStaticClient.top
        mov m_size.y, eax
        
        Invoke ClientToScreen, m_hBmpNew, Addr m_size
        Invoke ScreenToClient, m_hBmpNew, Addr m_size
        
        mov eax, rectStaticClient.left 
        mov m_pt.x, eax
        mov eax, rectStaticClient.top
        mov m_pt.y, eax 
        Invoke GetObject, m_hBmpNew, SIZEOF BITMAP, Addr m_bmInfo
        Invoke SelectObject, m_dcMem, m_hBmpNew
        mov m_hBmpOld, eax
        
    .ENDIF      
    
    mov eax, m_pt.x
    mov offsetx, eax
    mov eax, m_pt.y
    mov offsety, eax
    
    mov eax, offsetx
    add eax, m_size.x
    Invoke MoveWindow, hVSCROLL, eax, offsety, 18, m_size.y, TRUE
    
    mov eax, offsety
    add eax, m_size.y
    Invoke MoveWindow, hHSCROLL, offsetx, eax, m_size.x, 18, TRUE
    
    mov horz.cbSize, SIZEOF SCROLLINFO
    mov horz.fMask, SIF_ALL
    mov horz.nMin, 0
    mov eax, m_bmInfo.bmWidth
    mov ebx, m_size.x
    sub ebx, eax
    mov horz.nMax, eax
    mov horz.nPage, 0
    mov horz.nPos, 0
    mov horz.nTrackPos, 0
    
    mov ebx, m_bmInfo.bmWidth
    .IF ebx <= m_size.x
        mov eax, m_size.x
        sub eax, ebx
        .IF eax == 0
            mov eax, m_pt.x
            mov offsetx, eax
        .ELSE
            xor edx, edx
            mov ecx, 2
            div ecx
            mov ebx, m_pt.x
            add eax, ebx
            mov offsetx, eax    
        .ENDIF        
        mov ebx, m_bmInfo.bmWidth
        add eax, ebx
        Invoke MoveWindow, hVSCROLL, eax, offsety, 18, m_size.y, TRUE 
        Invoke ShowWindow, hHSCROLL, SW_HIDE
    .ELSE
        Invoke ShowWindow, hHSCROLL, SW_SHOW
    .ENDIF
    Invoke SetScrollInfo, hHSCROLL, SB_CTL, Addr horz, TRUE
    
    
    mov vert.cbSize, SIZEOF SCROLLINFO
    mov vert.fMask, SIF_ALL
    mov vert.nMin, 0
    mov eax, m_bmInfo.bmHeight
    mov ebx, m_size.y
    sub ebx, eax
    mov vert.nMax, eax
    mov vert.nPage, 0
    mov vert.nPos, 0
    mov vert.nTrackPos, 0    
    
    mov ebx, m_bmInfo.bmHeight
    .IF ebx <= m_size.y
        mov eax, m_size.y
        sub eax, ebx
        .IF eax == 0
            mov eax, m_pt.y
            mov offsety, eax
        .ELSE
            xor edx, edx
            mov ecx, 2
            div ecx
            mov ebx, m_pt.x
            add eax, ebx
            mov offsety, eax    
        .ENDIF        
        mov ebx, m_bmInfo.bmHeight
        add eax, ebx
        Invoke MoveWindow, hHSCROLL, offsetx, eax, m_size.x, 18, TRUE 
        Invoke ShowWindow, hVSCROLL, SW_HIDE
    .ELSE
        Invoke ShowWindow, hVSCROLL, SW_SHOW
    .ENDIF
    Invoke SetScrollInfo, hVSCROLL, SB_CTL, Addr vert, TRUE
    
    Invoke InvalidateRect, m_hBmpNew, Addr rectStaticClient, TRUE
    ret

LoadWorldMapBMP endp

end start
